using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.Data.OleDb;
using System.Diagnostics;
using System.IO;
using System.Drawing.Imaging;

using Syncfusion.Windows.Forms.Diagram;

namespace Syncfusion.Windows.Forms.Diagram.Samples.OrgLayout
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUpdateLayout;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemFileExit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemFile;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAdd;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSelectTool;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAutoLayout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCut;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemHelpAbout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDimensions;
		private Syncfusion.Windows.Forms.Diagram.Samples.OrgLayout.OrgChartManager orgChartManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemZoomTool;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItemMagnification;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSaveAs;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemOpenDiagram;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemReadDatabase;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemReadXMLData;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem4;
		private InsertSymbolTool insSymbolTool = null;
		private EmployeeSymbol newEmployee = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			this.orgChartManager = new Syncfusion.Windows.Forms.Diagram.Samples.OrgLayout.OrgChartManager();
			InitializeComponent();			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected Link CreateOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			return link;
		}

		protected Link CreateLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Line, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			return link;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Actions");
			this.barItemSelectTool = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAdd = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUpdateLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAutoLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemZoomTool = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.comboBoxBarItemMagnification = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.barItemDimensions = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "MainMenu");
			this.parentBarItemFile = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.parentBarItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemReadDatabase = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemReadXMLData = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemOpenDiagram = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemSaveAs = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemFileExit = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemEditCut = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemHelpAbout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.saveFileDialog1.FileName = "doc1";
			this.saveFileDialog1.Filter = "Diagram files|*.edd|All files|*.*";

			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog1.Filter = "Diagram Files|*.edd|All files|*.*";
			this.openFileDialog1.Title = "Open Diagram";
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.diagram);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 52);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(984, 522);
			this.panel1.TabIndex = 2;
			// 
			// diagram
			// 
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = this.orgChartManager;
			this.diagram.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagram.Model.BackgroundStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.BackgroundStyle.GradientBounds")));
			this.diagram.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.Properties = this.diagram.Model;
			this.diagram.Model.BackgroundStyle.Texture = null;
			this.diagram.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagram.Model.BoundaryConstraintsEnabled = true;
			this.diagram.Model.FillStyle.AlphaFactor = 255;
			this.diagram.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.GradientAngle = 90F;
			this.diagram.Model.FillStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.FillStyle.GradientBounds")));
			this.diagram.Model.FillStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.Properties = this.diagram.Model;
			this.diagram.Model.FillStyle.Texture = null;
			this.diagram.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyle.FillType.Solid;
			this.diagram.Model.Height = 1000F;
			this.diagram.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram.Model.LineStyle.DashOffset = 0F;
			this.diagram.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram.Model.LineStyle.LineWidth = 2F;
			this.diagram.Model.LineStyle.MiterLimit = 10F;
			this.diagram.Model.LineStyle.Properties = this.diagram.Model;
			this.diagram.Model.MeasurementScale = 1F;
			this.diagram.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram.Model.Name = "Model";
			this.diagram.Model.RenderingStyle.Properties = this.diagram.Model;
			this.diagram.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
			this.diagram.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.ShadowStyle.OffsetX = 6F;
			this.diagram.Model.ShadowStyle.OffsetY = 6F;
			this.diagram.Model.ShadowStyle.Properties = this.diagram.Model;
			this.diagram.Model.ShadowStyle.Visible = true;
			this.diagram.Model.Width = 3000F;
			this.diagram.Name = "diagram";
			this.diagram.NudgeIncrement = 1F;
			this.diagram.ScrollGranularity = 0.5F;
			this.diagram.Size = new System.Drawing.Size(984, 522);
			this.diagram.SmartSizeBox = false;
			this.diagram.TabIndex = 1;
			this.diagram.Text = "OrgLayout Diagram";
			// 
			// diagram.View
			// 
			this.diagram.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram.View.Grid.Color = System.Drawing.Color.White;
			this.diagram.View.Grid.DashOffset = 4F;
			this.diagram.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram.View.Grid.HorizontalSpacing = 10F;
			this.diagram.View.Grid.SnapToGrid = true;
			this.diagram.View.Grid.VerticalSpacing = 10F;
			this.diagram.View.Grid.Visible = true;
			this.diagram.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram.View.HandleColor = System.Drawing.Color.White;
			this.diagram.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram.View.HandleSize = 6;
			this.diagram.View.HorizontalRuler.Visible = false;
			this.diagram.View.MouseTrackingEnabled = true;
			this.diagram.View.PasteOffsetX = 10;
			this.diagram.View.PasteOffsetY = 10;
			this.diagram.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagram.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagram.View.RulerSize = 16;
			this.diagram.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagram.View.ShowPageBounds = false;
			this.diagram.View.VerticalRuler.Visible = false;
			this.diagram.View.MagnificationChanged += new Syncfusion.Windows.Forms.Diagram.ViewMagnificationEventHandler(this.diagram_View_MagnificationChanged);
			this.diagram.VScroll = true;
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.bar2);
			this.mainFrameBarManager.Bars.Add(this.bar1);
			this.mainFrameBarManager.Categories.Add("Actions");
			this.mainFrameBarManager.Categories.Add("File");
			this.mainFrameBarManager.Categories.Add("Edit");
			this.mainFrameBarManager.Categories.Add("Help");
			this.mainFrameBarManager.Categories.Add("View");
			this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.ImageList = this.imageList1;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.barItemLink,
																											 this.barItemUpdateLayout,
																											 this.barItemFileExit,
																											 this.parentBarItemFile,
																											 this.barItemAdd,
																											 this.barItemSelectTool,
																											 this.barItemAutoLayout,
																											 this.barItemEditCut,
																											 this.barItemEditCopy,
																											 this.barItemEditPaste,
																											 this.barItemHelpAbout,
																											 this.parentBarItem1,
																											 this.parentBarItem2,
																											 this.barItemDimensions,
																											 this.barItemReadDatabase,
																											 this.barItemZoomTool,
																											 this.parentBarItem3,
																											 this.comboBoxBarItemMagnification,
																											 this.barItemSaveAs,
																											 this.barItemOpenDiagram,
																											 this.barItemReadXMLData,
																											 this.parentBarItem4});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// bar2
			// 
			this.bar2.BarName = "Actions";
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemSelectTool,
																							  this.barItemAdd,
																							  this.barItemLink,
																							  this.barItemUpdateLayout,
																							  this.barItemAutoLayout,
																							  this.barItemZoomTool,
																							  this.comboBoxBarItemMagnification,
																							  this.barItemDimensions});
			this.bar2.Manager = this.mainFrameBarManager;
			// 
			// barItemSelectTool
			// 
			this.barItemSelectTool.CategoryIndex = 0;
			this.barItemSelectTool.ID = "Select";
			this.barItemSelectTool.ImageIndex = 0;
			this.barItemSelectTool.Text = "Select";
			this.barItemSelectTool.Tooltip = "Select Tool";
			this.barItemSelectTool.Click += new System.EventHandler(this.barItemSelectTool_Click);
			// 
			// barItemAdd
			// 
			this.barItemAdd.CategoryIndex = 0;
			this.barItemAdd.ID = "Add";
			this.barItemAdd.ImageIndex = 1;
			this.barItemAdd.Text = "Add";
			this.barItemAdd.Tooltip = "Add Member";
			this.barItemAdd.Click += new System.EventHandler(this.barItemAdd_Click);
			// 
			// barItemLink
			// 
			this.barItemLink.CategoryIndex = 0;
			this.barItemLink.ID = "Link";
			this.barItemLink.ImageIndex = 4;
			this.barItemLink.Text = "Link";
			this.barItemLink.Click += new System.EventHandler(this.barItemLink_Click);
			// 
			// barItemUpdateLayout
			// 
			this.barItemUpdateLayout.CategoryIndex = 0;
			this.barItemUpdateLayout.ID = "Update Layout";
			this.barItemUpdateLayout.ImageIndex = 5;
			this.barItemUpdateLayout.Text = "Update Layout";
			this.barItemUpdateLayout.Click += new System.EventHandler(this.barItemUpdateLayout_Click);
			// 
			// barItemAutoLayout
			// 
			this.barItemAutoLayout.CategoryIndex = 0;
			this.barItemAutoLayout.ID = "AutoLayout";
			this.barItemAutoLayout.ImageIndex = 2;
			this.barItemAutoLayout.Text = "AutoLayout";
			this.barItemAutoLayout.Tooltip = "Auto Layout";
			this.barItemAutoLayout.Click += new System.EventHandler(this.barItemAutoLayout_Click);
			// 
			// barItemZoomTool
			// 
			this.barItemZoomTool.CategoryIndex = 4;
			this.barItemZoomTool.ID = "Pan and Zoom Window";
			this.barItemZoomTool.Text = "Zoom";
			this.barItemZoomTool.Click += new System.EventHandler(this.barItemZoomTool_Click);
			// 
			// comboBoxBarItemMagnification
			// 
			this.comboBoxBarItemMagnification.CategoryIndex = 4;
			this.comboBoxBarItemMagnification.ChoiceList.AddRange(new string[] {
																				   "25%",
																				   "50%",
																				   "75%",
																				   "100%",
																				   "125%",
																				   "150%",
																				   "175%",
																				   "200%"});
			this.comboBoxBarItemMagnification.ID = "Magnification";
			this.comboBoxBarItemMagnification.Text = "Magnification";
			this.comboBoxBarItemMagnification.TextBoxValue = "100%";
			this.comboBoxBarItemMagnification.Click += new System.EventHandler(this.comboBoxBarItemMagnification_Click);
			// 
			// barItemDimensions
			// 
			this.barItemDimensions.CategoryIndex = 0;
			this.barItemDimensions.ID = "Dimensions";
			this.barItemDimensions.ImageIndex = 3;
			this.barItemDimensions.Text = "Dimensions";
			this.barItemDimensions.Click += new System.EventHandler(this.barItemDimensions_Click);
			// 
			// bar1
			// 
			this.bar1.BarName = "MainMenu";
			this.bar1.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.parentBarItemFile,
																							  this.parentBarItem1,
																							  this.parentBarItem3,
																							  this.parentBarItem2});
			this.bar1.Manager = this.mainFrameBarManager;
			// 
			// parentBarItemFile
			// 
			this.parentBarItemFile.CategoryIndex = 1;
			this.parentBarItemFile.ID = "File";
			this.parentBarItemFile.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										   this.parentBarItem4,
																										   this.barItemOpenDiagram,
																										   this.barItemSaveAs,
																										   this.barItemFileExit});
			this.parentBarItemFile.Text = "File";
			// 
			// parentBarItem4
			// 
			this.parentBarItem4.CategoryIndex = 1;
			this.parentBarItem4.ID = "Get Diagram Data";
			this.parentBarItem4.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemReadDatabase,
																										this.barItemReadXMLData});
			this.parentBarItem4.Text = "Get Diagram Data";
			// 
			// barItemReadDatabase
			// 
			this.barItemReadDatabase.CategoryIndex = 1;
			this.barItemReadDatabase.ID = "Read Data From Database";
			this.barItemReadDatabase.Text = "Read Data From Database";
			this.barItemReadDatabase.Click += new System.EventHandler(this.barItemReadDatabase_Click);
			// 
			// barItemReadXMLData
			// 
			this.barItemReadXMLData.CategoryIndex = 1;
			this.barItemReadXMLData.ID = "Read Data From XML File";
			this.barItemReadXMLData.Text = "Read Data From XML File";
			this.barItemReadXMLData.Click += new System.EventHandler(this.barItemReadXMLData_Click);
			// 
			// barItemOpenDiagram
			// 
			this.barItemOpenDiagram.CategoryIndex = 1;
			this.barItemOpenDiagram.ID = "Open Diagram...";
			this.barItemOpenDiagram.Text = "Open Diagram...";
			this.barItemOpenDiagram.Click += new System.EventHandler(this.barItemOpenDiagram_Click);
			// 
			// barItemSaveAs
			// 
			this.barItemSaveAs.CategoryIndex = 1;
			this.barItemSaveAs.ID = "Save Diagram As...";
			this.barItemSaveAs.Text = "Save Diagram As...";
			this.barItemSaveAs.Click += new System.EventHandler(this.barItemSaveAs_Click);
			// 
			// barItemFileExit
			// 
			this.barItemFileExit.CategoryIndex = 1;
			this.barItemFileExit.ID = "Exit";
			this.barItemFileExit.Text = "Exit";
			this.barItemFileExit.Click += new System.EventHandler(this.barItemFileExit_Click);
			// 
			// parentBarItem1
			// 
			this.parentBarItem1.CategoryIndex = 2;
			this.parentBarItem1.ID = "Edit";
			this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemEditCut,
																										this.barItemEditCopy,
																										this.barItemEditPaste});
			this.parentBarItem1.Text = "Edit";
			// 
			// barItemEditCut
			// 
			this.barItemEditCut.CategoryIndex = 2;
			this.barItemEditCut.ID = "Cut";
			this.barItemEditCut.ImageIndex = 6;
			this.barItemEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.barItemEditCut.Text = "Cu&t";
			this.barItemEditCut.Click += new System.EventHandler(this.barItemEditCut_Click);
			// 
			// barItemEditCopy
			// 
			this.barItemEditCopy.CategoryIndex = 2;
			this.barItemEditCopy.ID = "Copy";
			this.barItemEditCopy.ImageIndex = 7;
			this.barItemEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.barItemEditCopy.Text = "&Copy";
			this.barItemEditCopy.Click += new System.EventHandler(this.barItemEditCopy_Click);
			// 
			// barItemEditPaste
			// 
			this.barItemEditPaste.CategoryIndex = 2;
			this.barItemEditPaste.ID = "Paste";
			this.barItemEditPaste.ImageIndex = 8;
			this.barItemEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.barItemEditPaste.Text = "&Paste";
			this.barItemEditPaste.Click += new System.EventHandler(this.barItemEditPaste_Click);
			// 
			// parentBarItem3
			// 
			this.parentBarItem3.CategoryIndex = 4;
			this.parentBarItem3.ID = "View";
			this.parentBarItem3.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemZoomTool});
			this.parentBarItem3.Text = "View";
			// 
			// parentBarItem2
			// 
			this.parentBarItem2.CategoryIndex = 3;
			this.parentBarItem2.ID = "Help";
			this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemHelpAbout});
			this.parentBarItem2.Text = "Help";
			// 
			// barItemHelpAbout
			// 
			this.barItemHelpAbout.CategoryIndex = 3;
			this.barItemHelpAbout.ID = "About";
			this.barItemHelpAbout.Text = "About";
			this.barItemHelpAbout.Click += new System.EventHandler(this.barItemHelpAbout_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(984, 574);
			this.Controls.Add(this.panel1);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Organizational Layout";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			this.insSymbolTool = new InsertSymbolTool("InsertMemberSymbol", typeof(EmployeeSymbol));
			this.diagram.Controller.RegisterTool(this.insSymbolTool);

			// Attach link object factory to the link tool
			Tool linkTool = this.diagram.Controller.GetTool("LinkTool");
			if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
			{
				//((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
				((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
			}

			this.barItemAutoLayout.Checked = this.orgChartManager.AutoLayout;
			
			// Populate the Diagram with employee nodes from the Employees database
			this.InitializeDiagramFromDatabase();
		}

		private void barItemSaveAs_Click(object sender, System.EventArgs e)
		{
			// Save the diagram document as a binary file
			if(this.saveFileDialog1.ShowDialog(this) == DialogResult.OK)
			{
				this.diagram.SaveBinary(this.saveFileDialog1.FileName);
			}
		}
	
		private void barItemOpenDiagram_Click(object sender, System.EventArgs e)
		{
			// Open the specified diagram file
			if (this.openFileDialog1.ShowDialog(this) == DialogResult.OK)
			{
				if(this.diagram.LayoutManager != null)
					this.diagram.LayoutManager = null;
				this.diagram.LoadBinary(this.openFileDialog1.FileName);				
				this.diagram.LayoutManager = this.orgChartManager;
				this.diagram.Model.UpdateViews();
			}
		}

		private void barItemLink_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("LinkTool");
		}

		private void barItemUpdateLayout_Click(object sender, System.EventArgs e)
		{
			this.diagram.LayoutManager.UpdateLayout(null);
		}

		private void barItemAdd_Click(object sender, System.EventArgs e)
		{			
			OrgMemberInfoDlg infoDlg = new OrgMemberInfoDlg();
			if(infoDlg.ShowDialog(this) == DialogResult.OK)
			{
				// Might have previously subscribed to the Diagram.ConnectionsChangeComplete event. Unsubscribe.
				this.diagram.ConnectionsChangeComplete -= new Syncfusion.Windows.Forms.Diagram.ConnectionCollectionEventHandler(this.diagram_ConnectionsChangeComplete);

				this.orgChartManager.AutoLayout = false; // Temporarily suspend the layoutmanager

				EmployeeSymbol employeesym = new EmployeeSymbol();
				employeesym.EmployeeName = infoDlg.EmployeeName;
				employeesym.EmployeeID = infoDlg.EmployeeID;
				employeesym.ManagerID = infoDlg.ManagerID;
				this.insSymbolTool.Symbol = employeesym;
				this.diagram.Controller.ActivateTool(this.insSymbolTool);
				
				// Hold a reference to the newly inserted Symbol
				this.newEmployee = employeesym;

				// The new Employee node may be linked to a Manager node. Subscribing to the Diagram.ConnectionsChangeComplete 
				// event provides us access to the Manager symbol in the event of a new employer-employee Link being created.
				this.diagram.ConnectionsChangeComplete += new Syncfusion.Windows.Forms.Diagram.ConnectionCollectionEventHandler(this.diagram_ConnectionsChangeComplete);
			}
		}		
		
		private void diagram_ConnectionsChangeComplete(object sender, Syncfusion.Windows.Forms.Diagram.ConnectionCollectionEventArgs evtArgs)
		{
			// A new EmployeeSymbol was created using the Insert dialog and linked to a Manager node. The Link SourcePort 
			// container will be the Manager node for the new symbol.			
			if(this.newEmployee != null)
			{
				if((evtArgs.Connection != null) && (evtArgs.Connection.TargetPort is LinkTailPort) && (this.newEmployee.ManagerID == String.Empty))			
				{
					this.newEmployee.ManagerID = (evtArgs.Connection.SourcePort.Container as EmployeeSymbol).EmployeeID;				
					this.newEmployee = null;
				}
			}
			this.diagram.ConnectionsChangeComplete -= new Syncfusion.Windows.Forms.Diagram.ConnectionCollectionEventHandler(this.diagram_ConnectionsChangeComplete);
		}	

		private void barItemFileExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void barItemSelectTool_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("SelectTool");
		}

		private void barItemAutoLayout_Click(object sender, System.EventArgs e)
		{
			if (this.barItemAutoLayout.Checked)
			{
				this.barItemAutoLayout.Checked = false;
			}
			else
			{
				this.barItemAutoLayout.Checked = true;
			}
			this.orgChartManager.AutoLayout = this.barItemAutoLayout.Checked;
		}

		private void barItemEditCut_Click(object sender, System.EventArgs e)
		{
			this.diagram.Cut();
		}

		private void barItemEditCopy_Click(object sender, System.EventArgs e)
		{
			this.diagram.Copy();
		}

		private void barItemEditPaste_Click(object sender, System.EventArgs e)
		{
			this.diagram.Paste();
		}

		private void barItemDimensions_Click(object sender, System.EventArgs e)
		{
			DimensionsDlg dlg = new DimensionsDlg();

			dlg.DiagramWidth = this.diagram.Model.Width;
			dlg.DiagramHeight = this.diagram.Model.Height;

			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				this.orgChartManager.AutoLayout = false; // Temporarily suspend the layoutmanager
				this.diagram.Model.Width = dlg.DiagramWidth;
				this.diagram.Model.Height = dlg.DiagramHeight;
				this.orgChartManager.UpdateLayout(null);
			}
		}

		private void barItemHelpAbout_Click(object sender, System.EventArgs e)
		{
			AboutForm about = new AboutForm();
			about.ShowDialog(this);
		}

		private void barItemZoomTool_Click(object sender, System.EventArgs e)
		{
			Tool tool = this.diagram.Controller.GetTool("ZoomTool");
			if (tool != null)
			{
				if (tool.Active)
				{
					this.diagram.Controller.DeactivateTool(tool);
				}
				else
				{
					this.diagram.Controller.ActivateTool(tool);
				}
			}	
		}
	
		private void comboBoxBarItemMagnification_Click(object sender, System.EventArgs e)
		{
			string strMagValue = this.comboBoxBarItemMagnification.TextBoxValue;
			int idxPctSign = strMagValue.IndexOf('%');
			if (idxPctSign >= 0)
			{
				strMagValue = strMagValue.Remove(idxPctSign, 1);
			}
			int magVal = System.Convert.ToInt32(strMagValue);
			this.diagram.View.Magnification = new System.Drawing.Size(magVal, magVal);
			this.diagram.Refresh();
		}		

		private void diagram_View_MagnificationChanged(object sender, Syncfusion.Windows.Forms.Diagram.ViewMagnificationEventArgs evtArgs)
		{
			UpdateMagnificationComboBox();
		}
	
		private void UpdateMagnificationComboBox()
		{
			System.Drawing.Size szMag = this.diagram.View.Magnification;
			this.comboBoxBarItemMagnification.TextBoxValue = szMag.Width + "%";
		}
		
		private void barItemReadDatabase_Click(object sender, System.EventArgs e)
		{
			this.InitializeDiagramFromDatabase();			
		}
		
		private void barItemReadXMLData_Click(object sender, System.EventArgs e)
		{
			this.InitializeDiagramFromXMLFile();
		}		

		// Reads the employee data from the MS Access database and creates the diagram organization tree.
		private void InitializeDiagramFromDatabase()
		{
			// Clear the diagram model of all existing nodes
			if(this.diagram.Model.ChildCount > 0)
				this.diagram.Model.Clear();

			// Read data from the Access dataasource and populate a Hashtable using the employee ID as the key
			Hashtable htemployees = this.ReadEmployeeDataFromDatabase();

			// Create a manager-employee nested list with top-level employees forming the root nodes
			ArrayList sortedlist = this.GetSortedEmployeesList(htemployees);

			foreach(Employee emply in sortedlist)
				this.IterUpdateSubEmployeeCount(emply);	

			// Create diagram symbol nodes for each employee and initialize the diagram
			this.CreateOrgDiagramFromList(sortedlist);

			htemployees.Clear();
			sortedlist.Clear();
		}

		// Gets the employee data from an XML format file and creates the diagram organization tree.
		private void InitializeDiagramFromXMLFile()
		{
			// Clear the diagram model of all existing nodes
			if(this.diagram.Model.ChildCount > 0)
				this.diagram.Model.Clear();

			// Read data from the XML file and populate a Hashtable using the employee ID as the key
			Hashtable htemployees = this.ReadEmployeeDataFromXMLFile();

			// Create a manager-employee nested list with top-level employees forming the root nodes
			ArrayList sortedlist = this.GetSortedEmployeesList(htemployees);

			foreach(Employee emply in sortedlist)
				this.IterUpdateSubEmployeeCount(emply);	

			// Create diagram symbol nodes for each employee and initialize the diagram
			this.CreateOrgDiagramFromList(sortedlist);

			htemployees.Clear();
			sortedlist.Clear();
		}

		// Connect to the Access database and query the employee information using an ADO.NET data reader
		private Hashtable ReadEmployeeDataFromDatabase()
		{
			Hashtable htemployees = new Hashtable();

			// Connection string for the Org.mdb Access database
			string currentpath = Application.ExecutablePath;
			string datasrcpath = currentpath.Substring(0,currentpath.IndexOf("bin")) + "data\\employees.mdb";
			string connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + datasrcpath + ";";
			OleDbConnection orgdbconnection = new OleDbConnection(connectionstring);
			// Query to select all records from the Org.mbd database
			string orgdbselectquery = "SELECT EmployeeID, Name, ManagerID FROM Employees";
			OleDbCommand orgdbcommand = new OleDbCommand(orgdbselectquery, orgdbconnection);
			// Create a connection to the datasource
			orgdbconnection.Open();
			// Execute the query command to build the data reader			
			OleDbDataReader orgdbreader = orgdbcommand.ExecuteReader();
			// Extract employee data from the reader
			while(orgdbreader.Read()) 
			{				
				object[] employeedata = new object[3];
				int count = orgdbreader.GetValues(employeedata);				

				// Create an Employee instance to represent each employee
				Employee emply = new Employee();
				emply.EmployeeID = employeedata[0].ToString();
				emply.EmployeeName = (string)employeedata[1];
				if(count == 3)
					emply.ManagerID = employeedata[2].ToString();				
				htemployees.Add(emply.EmployeeID, emply);		
			}
			// Close the reader
			orgdbreader.Close();
			// Close the connection
			orgdbcommand.Connection.Close();
			
			return htemployees;
		}

		// Use the XMLDocument class to read the org chart data from the exported XML database file
		private Hashtable ReadEmployeeDataFromXMLFile()
		{
			Hashtable htemployees = new Hashtable();								

			// Use the XML DOM to read data from the XML org chart data file
			try
			{				
				string currentpath = Application.ExecutablePath;
				string filepath = currentpath.Substring(0,currentpath.IndexOf("bin")) + "data\\employees.xml";
				
				XmlDocument xmldoc = new XmlDocument();		
				xmldoc.Load(filepath);
				if(xmldoc.DocumentElement.HasChildNodes)
				{
					XmlNodeList employeelist = xmldoc.DocumentElement.ChildNodes;					
					for(int i=0; i<employeelist.Count; i++)
					{ 							
						// Create an Employee instance to represent each employee
						Employee emply = new Employee();
						XmlNode employeenode = employeelist[i];
						XmlNodeList employeedatalist = employeenode.ChildNodes;
						IEnumerator employeedata = employeedatalist.GetEnumerator();
						employeedata.Reset();
						while(employeedata.MoveNext())
						{
							XmlNode dataelement = employeedata.Current as XmlNode;
							switch(dataelement.Name)
							{
								case "Name":
									emply.EmployeeName = dataelement.InnerText;
									break;
								case "EmployeeID":
									emply.EmployeeID = dataelement.InnerText;
									break;
								case "ManagerID":
									emply.ManagerID = dataelement.InnerText;
									break;
							}
						}
						htemployees.Add(emply.EmployeeID, emply);		
					}
				}
			}
			catch
			{
				MessageBox.Show("Data Source not found", "Essential Diagram Sample", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		    
			return htemployees;
		}

		// Rearrange the employees collection as a manager-subemployee nested tree
		private ArrayList GetSortedEmployeesList(Hashtable htemployees)
		{
			ArrayList sortedlist = new ArrayList();
			foreach(Employee emply in htemployees.Values)
			{
				if(emply.ManagerID == String.Empty)
				{
					// Employees without a ManagerID are top-level nodes in the org tree
					sortedlist.Add(emply);
				}
				else
				{
					// Find the employee instance associated with the managerID and add this object as 
					// a subemployee of the manager node.
					Employee manager = (Employee)htemployees[emply.ManagerID];
					if(manager != null)
						manager.SubEmployees.Add(emply);											
				}
			}

			return sortedlist;
		}
		
		private void IterUpdateSubEmployeeCount(Employee empl)
		{		
			empl.RecSubEmployeeCount = empl.SubEmployees.Count;
			foreach(Employee subempl in empl.SubEmployees)
			{
				this.IterUpdateSubEmployeeCount(subempl);				
				empl.RecSubEmployeeCount += subempl.RecSubEmployeeCount;
			}
		}
		
		// Create diagram symbol nodes for each employee in the organization and add these symbols to the diagram
		// Create links between manager and sub-employees to depict the org structure
		private void CreateOrgDiagramFromList(ArrayList alemployees)
		{		
			this.orgChartManager.AutoLayout = false; // Temporarily suspend the layoutmanager
			foreach(Employee emply in alemployees)
			{				
				// Create a EmployeeSymbol for each employee in the organization and add the membersymbol to 
				// the diagram.			
				EmployeeSymbol emplysymbol = new EmployeeSymbol();
				emplysymbol.EmployeeName = emply.EmployeeName;
				emplysymbol.EmployeeID = emply.EmployeeID;
				emplysymbol.RecSubEmployeeCount = emply.RecSubEmployeeCount;

				// Merely add the various symbols to the Diagram. Positioning the various nodes within the 
				// diagram will be the responsibility of the OrgChartManager LayoutManager. Nodes will be 
				// positioned based on their level in the organization hierarchy.
				this.diagram.Model.AppendChild(emplysymbol);

				this.IterCreateEmployeeSymbol(emply, emplysymbol);
			}
			// Instruct the LayoutManager to calculate and layout the diagram nodes
			this.orgChartManager.UpdateLayout(null);
		}

		// Iterative sub-employee symbol node creation
		private void IterCreateEmployeeSymbol(Employee emply, EmployeeSymbol emplysymbol)
		{
			foreach(Employee subemply in emply.SubEmployees)
			{
				// Create a EmployeeSymbol for each of the sub-employees of the particular employee
				EmployeeSymbol subemplysymbol = new EmployeeSymbol();
				subemplysymbol.EmployeeName = subemply.EmployeeName;
				subemplysymbol.EmployeeID = subemply.EmployeeID;
				subemplysymbol.ManagerID = subemply.ManagerID;
				subemplysymbol.RecSubEmployeeCount = subemply.RecSubEmployeeCount;
				
				this.diagram.Model.AppendChild(subemplysymbol);			

				// Create a Link node to connect the employee symbol with it's subemployee symbol.
				Syncfusion.Windows.Forms.Diagram.Link link = new Syncfusion.Windows.Forms.Diagram.Link(Link.Shapes.Line);				
				emplysymbol.Connect(emplysymbol.CenterPort, link.TailPort);
				subemplysymbol.Connect(link.HeadPort, subemplysymbol.CenterPort);
				this.diagram.Model.AppendChild(link);
				this.diagram.Model.SendToBack(link);

				this.IterCreateEmployeeSymbol(subemply, subemplysymbol);
			}
		}				
					
	}   

}
